      PROGRAM FALC
C  FOURIER ANALYSIS OF LIGHTCURVES
$LARGE: A
      DIMENSION NPTS(100), IPIV(100), AUX(200), XM(1000), SIG(1000),
     +XME(1000), B(1000), X(100), A(32000)
      REAL*8 T(1000), P, DP, PX, DPX, T0, TX(1000)
      CHARACTER IN(80), SIGPLT(30), FN1(16)
      CHARACTER*6 PA(100)
      CHARACTER*12 DATE(100)
      CHARACTER*9 NAME
      CHARACTER*16 FN
      CHARACTER*80 IN80
      EQUIVALENCE (IN(1), IN80), (FN1(1), FN)
      DATA SIGPLT/' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
     +' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
     +' '/
C  ENTER INPUT FILE NAME
    1 WRITE(*,'('' Enter input file name (CR to stop): ''\)')
      READ(*,'(A16)') FN
      IF(FN.EQ.' ') STOP
      DO 18 NF = 1,15
      IF(FN1(NF).EQ.'.') GO TO 20
   18 IF(FN1(NF).EQ.' ') GO TO 19
   19 FN1(NF) = '.'
      FN1(NF+1) = 'V'
   20 OPEN(1,FILE=FN)
C  OPEN FILE FOR SCAN OUTPUT
      FN1(NF+1) = 'S'
      FN1(NF+2) = 'C'
      FN1(NF+3) = 'N'
      OPEN(3,FILE=FN,STATUS='NEW')
      SCL = 10.
C  READ DATA FILE
      NLC = 0
      NTOT = 0
      IFLAG = 0
      NFIT = 4
      NFITX = 4
      P = 10.
      DP = .01
      NP = 10
      EPS = 0.
      SIG2 = 0.
      T0 = 0.
    2 READ(1,'(A80)',END=12) IN80
      IF(IN(1).NE.'V') THEN
      WRITE(*,'(1X, A80)') IN80
      IF(IN(1).EQ.'X') GO TO 2
      IF(IN(1).EQ.'*') GO TO 12
      IFLAG = 0
      READ(IN80,'(A9, A12, 14X, A6)') NAME, DATE(NLC+1), PA(NLC+1)
      ELSE
      IF(IFLAG.EQ.0) THEN
      IFLAG = 1
      NLC = NLC + 1
      NPTS(NLC) = 0
      END IF
      NTOT = NTOT + 1
      NPTS(NLC) = NPTS(NLC) + 1
      READ(IN80,'(10X, F11.5, 7X, F6.3, F5.3)') T(NTOT), XM(NTOT),
     +SIG(NTOT)
      IF(SIG(NTOT).LE.0.) SIG(NTOT) = 0.01
      SIGX = 1./SIG(NTOT)**2
      T0 = T0 + T(NTOT)*DBLE(SIGX)
      SIG2 = SIG2 + SIGX
      WRITE(*,'(1X, F11.5, F7.3, F5.3)') T(NTOT), XM(NTOT), SIG(NTOT)
      XME(NTOT) = XM(NTOT)/SIG(NTOT)
      END IF
      GO TO 2
   12 T0 = DNINT(T0/DBLE(SIG2) + 0.5D0) - 0.5D0
      DO 13 I = 1, NTOT
   13 TX(I) = T(I) - T0
      SIG2 = SQRT(1./SIG2)
C  CALL FOR CONTROL DATA
    3 IF(NFITX.LT.0) NFITS = NFITX
      IF(NFITX.GT.0) NFITS = NFIT
      WRITE(*,'(6H0NLC =, I3, 9H   NTOT =, I4//'' Enter fit order, perio
     +d, scan increment, scan length, and plot scale below''/'' current
     +values (No entry to leave unchanged, negative fit order for period
     +''/'' scan, letter entry to display solution):''/1X, I5, 2F10.5,
     +I5, F10.2)') NLC, NTOT, NFITS, P, DP, NP, SCL
      READ(*,'(I5, 2F10.5, I5, F10.2)',ERR=8) NFITX, PX, DPX, NPX, SCLX
      IF(NFITX.EQ.0) NFITX = NFITS
      IF(NFITX.LT.0) GO TO 14
      IF(NFITX.GT.0) NFIT = NFITX
      IF(PX.GT.0.D0) P = PX
      IF(DPX.GT.0.D0) DP = DPX
      IF(DPX.LT.0.D0) DP = 0.
   15 IF(NPX.GT.0) NP = NPX
      IF(SCLX.GT.0.) SCL = SCLX
      SCALE = 30./SCL
C  SCAN RANGE OF PERIODS
      DO 7 I = 1,NP
      PX = P/24.D0
C  FILL ARRAY ELEMENTS
      NORDER = NLC + 2*NFIT
      XNK = FLOAT(NTOT-NORDER)
      DSIG = 1. + 0.5/XNK
      DO 4 J = 1,NTOT*NLC
    4 A(J) = 0.
      DO 5 J = 1,NTOT
    5 B(J) = XME(J)
      L = 0
      DO 6 J = 1,NLC
      NPX = NPTS(J)
      DO 6 K = 1,NPX
      L = L + 1
      A(NTOT*(J-1)+L) = 1./SIG(L)
      PHASE = DMOD(TX(L)/PX,1.D0)*6.283185307D0
      DO 6 LL = 1,NFIT
      A((NLC+2*LL-2)*NTOT+L) = SIN(FLOAT(LL)*PHASE)/SIG(L)
    6 A((NLC+2*LL-1)*NTOT+L) = COS(FLOAT(LL)*PHASE)/SIG(L)
C  COMPUTE SOLUTION CONSTANTS
      CALL LLSQ(A,B,NTOT,NORDER,1,X,IPIV,EPS,IER,AUX)
      IF(IER.NE.0) THEN
      WRITE(*,'('' INVERSION ERROR ='', I3)') IER
      GO TO 3
      END IF
      AUX(1) = SQRT(AUX(1)/XNK)
      SIGMA = SIG2*AUX(1)
      SIGX = SIGMA*DSIG
      ISIG = SCALE*AUX(1) + 0.5
      IF(ISIG.GT.30) ISIG = 30
      SIGPLT(ISIG) = '+'
      WRITE(3,'(2F9.5)') P, AUX(1)
      WRITE(*,'(I3, F10.5, F8.5, 30A1, 2F9.7, I4, 3H of, I4)') NFIT, P,
     +AUX(1), SIGPLT, SIGMA, SIGX, I, NP
      SIGPLT(ISIG) = ' '
      IF(DP.EQ.0.D0) NFIT = NFIT + 1
      IF(NFITX.LT.0) DP = DP*DPX
    7 P = P + DP
      GO TO 3
C  DISPLAY CURRENT SOLUTION
    8 PX = P - DP
      IF(DP.EQ.0.D0) NFIT = NFIT - 1
      WRITE(*,'(6H0NLC =, I3, 9H   NTOT =, I4, 9H   NFIT =, I3,
     +7H   T0 =, F8.1/4H P =, F10.5, 8H   DSP =, F8.5, 7H   PE =, F9.7/
     +(10F7.4))') NLC, NTOT, NFIT, T0, PX, AUX(1), SIGMA, (X(I),
     +I=1,NORDER)
C  WRITE OUTPUT FILES
      WRITE(*,'('' Enter CR to continue, N for new input file, X to stop
     +, or file name to''/'' write output files: ''\)')
      READ(*,'(A12)') FN
      IF(FN.EQ.' ') GO TO 3
      IF((FN.EQ.'X').OR.(FN.EQ.'x')) THEN
      END FILE 3
      CLOSE (3)
      STOP
      END IF
      IF((FN.EQ.'N').OR.(FN.EQ.'n')) GO TO 1
      DO 16 NF = 1,13
      IF(FN1(NF).EQ.'.') GO TO 21
   16 IF(FN1(NF).EQ.' ') GO TO 17
   17 FN1(NF) = '.'
      FN1(NF+1) = 'C'
      FN1(NF+2) = 'M'
      FN1(NF+3) = 'P'
   21 OPEN(2,FILE=FN,STATUS='NEW')
      FN1(NF+1) = 'F'
      FN1(NF+2) = 'A'
      FN1(NF+3) = 'Z'
      OPEN(4,FILE=FN,STATUS='NEW')
      WRITE(2,'(5HNLC =, I3, 9H   NTOT =, I4, 9H   NFIT =, I3,
     +7H   T0 =, F8.1/3HP =, F11.6, 8H   DSP =, F8.5, 7H   PE =, F9.7/
     +(1HF, 9F8.4))') NLC, NTOT, NFIT, T0, PX, AUX(1), SIGMA, (X(I),
     +I=1,NORDER)
      WRITE(*,'(6H NLC =, I3, 9H   NTOT =, I4, 9H   NFIT =, I3,
     +7H   T0 =, F8.1/4H P =, F11.6, 8H   DSP =, F8.5, 7H   PE =, F9.7/
     +(2H F, 9F8.4))') NLC, NTOT, NFIT, T0, PX, AUX(1), SIGMA, (X(I),
     +I=1,NORDER)
      PH = PX
C  COMPUTED LIGHTCURVE
      WRITE(2,'(13H//pos 0 0 1 1/3H/ag/7H/st OFF/9H/sa m 1 2/9H/sa n 1 2
     +/7H/sm OFF/6H/sc ON/6H/sd ON/7H/sb OFF/9H/se x OFF/9H/se y OFF/8H/
     +td "xy"/9H//abs_err/10H//half_err/6H//lt ",I2,15Hth Order Fit" 2)'
     +) NFIT
      PHASE = 0.
      DTH = .005*PH
      TH = 0.
      DO 23 I = 1, 221
      CMAG = 0.
      DO 22 J = 1, NFIT
   22 CMAG = CMAG + X(NLC+2*J-1)*SIN(FLOAT(J)*PHASE) + X(NLC+2*J)*
     +COS(FLOAT(J)*PHASE)
      WRITE(2,'(F10.4, F8.4)') TH, CMAG
      TH = TH + DTH
   23 PHASE = PHASE + .031415926536
C  COMPUTE COMPOSITE LIGHTCURVE AND RESIDUALS
      PX = PX/24.
      K = NTOT
      IX = 1
      DO 11 I = NLC,1,-1
      IX=IX+1
      K = K - NPTS(I)
      WRITE(2,'(4H//nc/6H/sa m ,I2,2H 2/9H/sa n 1 2/6H/sm ON/7H/sc OFF/
     +8H/se y ON/9H/td "xye"/6H//lt ",A12,3H" 2)') IX, DATE(I)
      NPX = NPTS(I)
      RESX = 0.
      SIGX = 0.
C  COMPUTE MAGNITUDES AND RESIDUALS
      DO 10 J = K+1,K+NPX
      PHASE = DMOD(TX(J)/PX,1.D0)
      IF(PHASE.LT.0.) PHASE = PHASE + 1.
      PHASER = PHASE*6.283185307D0
      PHASEH = PHASE*PH
      CMAG = 0.
      DO 9 L = 1,NFIT
    9 CMAG = CMAG + X(NLC+2*L-1)*SIN(FLOAT(L)*PHASER) + X(NLC+2*L)*
     +COS(FLOAT(L)*PHASER)
      CMAG = CMAG + X(I)
      RES = XM(J) - CMAG
      RS = RES/SIG(J)
      RESX = RESX + RS**2
      SIGX = SIGX + 1./SIG(J)**2
      DMAG = XM(J) - X(I)
      WRITE(*,'(1X,F10.4,F8.4,F6.3,F12.5,3F7.3,F7.4,F7.3)') PHASEH,
     +DMAG, SIG(J), T(J), XM(J), CMAG, RES, RS, PHASE
      WRITE(2,'(F10.4,F8.4,F6.3)') PHASEH, DMAG, SIG(J)
      IF(PHASE.LE.0.1) THEN
      PHASEH = PHASEH + PH
      WRITE(2,'(F10.4,F8.4,F6.3)') PHASEH, DMAG, SIG(J)
      END IF
   10 CONTINUE
C  WRITE PHASE FILE
      IF(NPX.LE.1) THEN
      RESX = 1.
      SIGX = SIG(J)
      ELSE
      RESX = SQRT(FLOAT(NTOT)*RESX/FLOAT(NPX-1)/XNK)
      SIGX = RESX/SQRT(SIGX)
      END IF
      WRITE(4,'(A6, 2F10.3, 4X, A12)') PA(I), X(I), SIGX, DATE(I)
   11 WRITE(*,'(8H Phase =, A6, 12H  Mean Mag =, F7.3, 7H  DSP =, F8.5,
     +6H  PE =, F9.7, 2X, A12)') PA(I), X(I), RESX, SIGX, DATE(I)
      WRITE(2,'(4H//nc/23H/et x "U. T.  Hours, 24, F7.1, 1H"/5H/oa g/10H
     +/oaam x ON/11H/oaamm x ON/8H/ogs x h/26H/et y "Relative Magnitude"
     +/9H/orr y ON/5H/oa g/10H/oaam y ON/11H/oaamm y ON/8H/ogs y h/7H/et
     + g ",A9,6H   P =,F9.5,7H Hours"/8H/oll 0 0/7H/og OFF)')T0,NAME,PH
      END FILE 2
      CLOSE (2)
      END FILE 4
      CLOSE (4)
      GO TO 3
C  SET UP PERIOD SCAN
   14 NFIT = -NFITX
      IF(PX.GT.0.) P = PX
      IF(DPX.NE.0.) DP = DPX
      DPX = 1. + 2.*DP/P
      GO TO 15
      END
      SUBROUTINE LLSQ(A,B,M,N,L,X,IPIV,EPS,IER,AUX)
C  LINEAR LEAST SQUARES SOLUTION, (B-A*X)**2=MINIMUM.  SEE IBM SSP
C  P. 191-195 FOR DESCRIPTION.
C  A = M BY N COEFFICIENT MATRIX (DESTROYED).
C  B = M BY L RIGHT SIDE MATRIX (DESTROYED).
C  M = NUMBER OF ROWS OF MATRICES A AND B
C  N = NUMBER OF COLUMNS OF MATRIX A, ROWS OF MATRIX X
C  L = NUMBER OF COLUMNS OF MATRICES B AND X
C  X = N BY L SOLUTION MATRIX
C  IPIV = N DIMENSIONED VECTOR OF COLUMN INTERCHANGES
C  EPS = INPUT PARAMETER TO SPECIFY RELATIVE TOLERANCE FOR RANK OF A
C  IER = OUTPUT ERROR PARAMETER, 0 FOR SUCCESSFUL INVERSION
C  AUX = AUX. STORAGE ARRAY, DIMENSION MAX(2*N,L)
C        FIRST L LOCATIONS CONTAIN THE RESULTING LEAST SQUARES.
      DIMENSION A(1),B(1),X(1),IPIV(1),AUX(1)
C  ERROR TEST
      IF(M-N) 30,1,1
C  GENERATION OF INITIAL VECTOR S(1-N) IN LOCATIONS AUX(1-N)
    1 PIV=0.
      IEND=0
      DO 4 K=1,N
      IPIV(K)=K
      H=0.
      IST=IEND+1
      IEND=IEND+M
      DO 2 I=IST,IEND
    2 H=H+A(I)*A(I)
      AUX(K)=H
      IF(H-PIV) 4,4,3
    3 PIV=H
      KPIV=K
    4 CONTINUE
C  ERROR TEST
      IF(PIV) 31,31,5
C  DEFINE TOLERANCE FOR CHECKING RANK OF A
    5 SIG=SQRT(PIV)
      TOL=SIG*ABS(EPS)
C  DECOMPOSITION LOOP
      LM=L*M
      IST=-M
      DO 21 K=1,N
      IST=IST+M+1
      IEND=IST+M-K
      I=KPIV-K
      IF(I) 8,8,6
C  INTERCHANGE K-TH COLUMN OF A WITH KPIV-TH IN CASE KPIV.GT.K
    6 H=AUX(K)
      AUX(K)=AUX(KPIV)
      AUX(KPIV)=H
      ID=I*M
      DO 7 I=IST,IEND
      J=I+ID
      H=A(I)
      A(I)=A(J)
    7 A(J)=H
C  COMPUTATION OF PARAMETER SIG
    8 IF(K-1) 11,11,9
    9 SIG=0.
      DO 10 I=IST,IEND
   10 SIG=SIG+A(I)*A(I)
      SIG=SQRT(SIG)
C  TEST ON SINGULARITY
      IF(SIG-TOL) 32,32,11
C  GENERATE CORRECT SIGN OF PARAMETER SIG
   11 H=A(IST)
      IF(H) 12,13,13
   12 SIG=-SIG
C  SAVE INTERCHANGE INFORMATION
   13 IPIV(KPIV)=IPIV(K)
      IPIV(K)=KPIV
C  GENERATION OF VECTOR UK IN K-TH COL.OF A AND OF PARAMETER BETA
      BETA=H+SIG
      A(IST)=BETA
      BETA=1./(SIG*BETA)
      J=N+K
      AUX(J)=-SIG
      IF(K-N) 14,19,19
C  TRANSFORMATION OF MATRIX A
   14 PIV=0.
      ID=0
      JST=K+1
      KPIV=JST
      DO 18 J=JST,N
      ID=ID+M
      H=0.
      DO 15 I=IST,IEND
      II=I+ID
   15 H=H+A(I)*A(II)
      H=BETA*H
      DO 16 I=IST,IEND
      II=I+ID
   16 A(II)=A(II)-A(I)*H
C  UPDATING OF ELEMENT S(J) STORED IN LOCATION AUX(J)
      II=IST+ID
      H=AUX(J)-A(II)*A(II)
      AUX(J)=H
      IF(H-PIV)18,18,17
   17 PIV=H
      KPIV=J
   18 CONTINUE
C  TRANSFORMATION OF RIGHT HAND SIDE MATRIX B
   19 DO 21 J=K,LM,M
      H=0.
      IEND=J+M-K
      II=IST
      DO 20 I=J,IEND
      H=H+A(II)*B(I)
   20 II=II+1
      H=BETA*H
      II=IST
      DO 21 I=J,IEND
      B(I)=B(I)-A(II)*H
   21 II=II+1
C  END OF DECOMPOSITION LOOP
C  BACK SUBSTITUTION AND BACK INTERCHANGE
      IER=0
      I=N
      LN=L*N
      PIV=1./AUX(2*N)
      DO 22 K=N,LN,N
      X(K)=PIV*B(I)
   22 I=I+M
      IF(N-1)26,26,23
   23 JST=(N-1)*M+N
      DO 25 J=2,N
      JST=JST-M-1
      K=N+N+1-J
      PIV=1./AUX(K)
      KST=K-N
      ID=IPIV(KST)-KST
      IST=2-J
      DO 25 K=1,L
      H=B(KST)
      IST=IST+N
      IEND=IST+J-2
      II=JST
      DO 24 I=IST,IEND
      II=II+M
   24 H=H-A(II)*X(I)
      I=IST-1
      II=I+ID
      X(I)=X(II)
      X(II)=PIV*H
   25 KST=KST+M
C  COMPUTATION OF LEAST SQUARES
   26 IST=N+1
      IEND=0
      DO 29 J=1,L
      IEND=IEND+M
      H=0.
      IF(M-N) 29,29,27
   27 DO 28 I=IST,IEND
   28 H=H+B(I)*B(I)
      IST=IST+M
   29 AUX(J)=H
      RETURN
C  ERROR RETURN IN CASE M LESS THAN N
   30 IER=-2
      RETURN
C  ERROR RETURN IN CASE OF ZERO MATRIX A
   31 IER=-1
      RETURN
C  ERROR RETURN IN CASE OF RANK OF A LESS THAN N
   32 IER=K-1
      RETURN
      END
